package com.sun.jndi.url.rmi;

import javax.naming.NamingException;
import com.sun.jndi.rmi.registry.RegistryContext;
import javax.naming.CompositeName;
import javax.naming.spi.ResolveResult;
import java.util.Hashtable;
import com.sun.jndi.toolkit.url.GenericURLContext;

public class rmiURLContext extends GenericURLContext
{
    public rmiURLContext(Hashtable<?, ?> env) {
        super(env);
    }
    
    @Override
    protected ResolveResult getRootURLContext(String str, Hashtable<?, ?> env) throws NamingException {
        if (!str.startsWith("rmi:")) {
            throw new IllegalArgumentException("rmiURLContext: name is not an RMI URL: " + str);
        }
        String s = null;
        int int1 = -1;
        String substring = null;
        int n = 4;
        if (str.startsWith("//", n)) {
            n += 2;
            int endIndex = str.indexOf(47, n);
            if (endIndex < 0) {
                endIndex = str.length();
            }
            int n2;
            if (str.startsWith("[", n)) {
                int index2 = str.indexOf(93, n + 1);
                if (index2 < 0 || index2 > endIndex) {
                    throw new IllegalArgumentException("rmiURLContext: name is an Invalid URL: " + str);
                }
                s = str.substring(n, index2 + 1);
                n2 = index2 + 1;
            }
            else {
                int index = str.indexOf(58, n);
                index = ((index < 0 || index > endIndex) ? endIndex : index);
                if (n < index) {
                    s = str.substring(n, index);
                }
                n2 = index;
            }
            if (n2 + 1 < endIndex) {
                if (str.startsWith(":", n2)) {
                    ++n2;
                    int1 = Integer.parseInt(str.substring(n2, endIndex));
                }
                else {
                    throw new IllegalArgumentException("rmiURLContext: name is an Invalid URL: " + str);
                }
            }
            n = endIndex;
        }
        if ("".equals(s)) {
            s = null;
        }
        if (str.startsWith("/", n)) {
            ++n;
        }
        if (n < str.length()) {
            substring = str.substring(n);
        }
        CompositeName rname = new CompositeName();
        if (substring != null) {
            rname.add(substring);
        }
        return new ResolveResult(new RegistryContext(s, int1, env), rname);
    }
}
